<?php
/*
Plugin Name: Защита от подбора паролей
Plugin URI: http://rusvc.ru
Description: Блокирует вход по IP в случае неверного ввода пароля несколько раз подряд
Version: 1.0
Author: RusVC
Author URI: http://ivbutusov.ru
*/

add_action('admin_menu', 'rusvc_login_lock_menu');

function rusvc_login_lock_menu() {
	$h_chan = add_users_page('Защита от подбора паролей', 'Защита от подбора паролей', 'manage_options', 'rusvc-login-lock', 'rusvc_login_lock_page');
}

function rusvc_login_lock_page() {
    global $wpdb;
	global $table_prefix;
	
	$msg1 = '';
	$msg2 = '';
	$msg3 = '';
	
	if( wp_verify_nonce($_POST['rusvc-login-lock-save'], 'rusvc-login-lock-save-opts') ) {
	    if(isset($_POST['fails']) && is_numeric($_POST['fails'])) $fails = intval($_POST['fails']); else $fails = null;
        if(isset($_POST['hours']) && is_numeric($_POST['hours'])) $hours = intval($_POST['hours']); else $hours = null;
        if($fails !== null && $fails >= 1 && $fails <= 100)
            update_option('rusvc_login_lock_blk_fails', $fails);
        else $msg1 = '<div class="error"><p>Неверно указано количество вводов до блокировки.</p></div>';
        if($hours !== null && $hours >= 1 && $hours <= 100)
            update_option('rusvc_login_lock_blk_hours', $hours);
        else $msg1 = '<div class="error"><p>Неверно указано количество часов до разблокировки.</p></div>';
	}
	
	if( wp_verify_nonce($_POST['rusvc-login-lock-del'], 'rusvc-login-lock-clear') ) {
	    if($wpdb->query("TRUNCATE TABLE `".$table_prefix."rusvc_login_lock`")) $msg2 = '<div class="updated"><p>Блокировки сброшены</p></div>';
	}
	
	if( wp_verify_nonce($_POST['rusvc-login-lock-ls'], 'rusvc-login-lock-list') ) {
	    if(isset($_POST['dels']) && is_array($_POST['dels']) && count($_POST['dels']) > 0) {
	        $dels = $_POST['dels'];
	        $ids_str = '';
	        for($i=0; $i<count($dels); $i++){
	            $dels[$i] = intval($dels[$i]);
	            $ids_str .= $dels[$i];
	            if($i < count($dels) - 1) $ids_str .= ', ';
	        }
	        if($wpdb->query("DELETE FROM `".$table_prefix."rusvc_login_lock` WHERE bid IN (". $ids_str .")")) $msg3 = '<div class="updated"><p>Выбранные счётчики и блокировки удалены.</p></div>';
	    }
	    else $msg3 = '<div class="error"><p>Пустой запрос.</p></div>';
	}
	
	$fails = get_option('rusvc_login_lock_blk_fails') - 1;
    $hours = get_option('rusvc_login_lock_blk_hours');
    
    $tzoffset = get_option('gmt_offset') * 3600;
	
	$all_cnt = $wpdb->get_var('SELECT count(bid) FROM '.$table_prefix.'rusvc_login_lock');
	$blocked_cnt = $wpdb->get_var('SELECT count(bid) FROM '.$table_prefix.'rusvc_login_lock WHERE fails>'.$fails);
?>
<div class="wrap"><h2>Настройки блокировки входа</h2>
<?php echo $msg1 . $msg2 . $msg3; ?>
<form action="" method="POST">
    <table class="form-table">
		<tr>
			<th scope="row">Количество неверных вводов пароля до блокировки</th>
			<td><input type="number" name="fails" min="1" max="100" value="<?php echo get_option('rusvc_login_lock_blk_fails'); ?>" /></td>
		</tr>
		<tr>
			<th scope="row">Часов до разблокировки</th>
			<td><input type="number" name="hours" min="1" max="100" value="<?php echo get_option('rusvc_login_lock_blk_hours'); ?>" /></td>
		</tr>
	</table>
    <p><input type="submit" name="save" value="Сохранить" class="button-primary" /></p>
    <?php wp_nonce_field('rusvc-login-lock-save-opts', 'rusvc-login-lock-save'); ?>
</form>

<hr>

<p>&nbsp;</p>
<h3>Список адресов (заблокировано <?=$blocked_cnt?>, всего <?=$all_cnt?>)</h3>
<p><em>Можно разблокировать какой-либо адрес, удалив его из списка.</em></p>
<?php
    $ips = $wpdb->get_results('SELECT bid, ip, fails, unlock_time FROM '.$table_prefix.'rusvc_login_lock ORDER BY fails DESC, unlock_time DESC', ARRAY_A);
?>
	<form method="post" action="">
	    <?php foreach($ips as $i) {
	            if($i['fails'] > $fails) $color = ' style="color:#a11;"'; else $color = '';
	            echo '<p' . $color . '><input type="checkbox" name="dels[]" value="' . $i['bid'] . '" /> <strong>' . $i['ip'] . "</strong> - до <em>" . date('d.m.Y H:i', $i['unlock_time'] + $tzoffset) . '</em></p>';
	    } ?>
        <p><input type="submit" name="unblock" class="button-primary" value="Разблокировать выбранное" /></p>
		<?php wp_nonce_field('rusvc-login-lock-list', 'rusvc-login-lock-ls'); ?>
	</form>

<hr>

<p>&nbsp;</p>
<h3>Сбросить все счётчики попыток (<?=$all_cnt?>)</h3>
<p><em>Со всех заблокированных адресов снова можно будет попробовать авторизоваться.</em></p>
	<form method="post" action="">
        <p><input type="submit" name="noblock" class="button-primary" value="Сброс" /></p>
		<?php wp_nonce_field('rusvc-login-lock-clear', 'rusvc-login-lock-del'); ?>
	</form>

<?php
}

add_filter('authenticate', 'rusvc_login_lockcheck', 1, 0);

function rusvc_login_lockcheck() {
    global $wpdb;
	global $table_prefix;
    $wpdb->query('DELETE FROM `'.$table_prefix.'rusvc_login_lock` WHERE unlock_time<' . time());
    $ip = $_SERVER['REMOTE_ADDR'];
    $fails = get_option('rusvc_login_lock_blk_fails') - 1;
    if( $wpdb->get_var('SELECT `bid` FROM `'.$table_prefix.'rusvc_login_lock` WHERE ip="' . $ip . '" AND fails>' . $fails . ' LIMIT 1') ){
        wp_die('С Вашего IP-адреса было слишком много попыток ввода некорректных логинов и паролей, поэтому вход заблокирован. Можете попробовать снова спустя несколько часов.');
    }
    return $user;
}

add_filter('authenticate', 'rusvc_login_prelock', 20, 3);

function rusvc_login_prelock($user, $username, $password) {
    global $wpdb;
	global $table_prefix;
    $ip = esc_sql($_SERVER['REMOTE_ADDR']);
    $fails = get_option('rusvc_login_lock_blk_fails');
    $hours = get_option('rusvc_login_lock_blk_hours');
    $unlock_time = time() + $hours*3600;
    if( isset( $user->errors['invalid_username'] ) || isset( $user->errors['incorrect_password'] ) ){
        if($ourfails = $wpdb->get_var('SELECT `fails` FROM `'.$table_prefix.'rusvc_login_lock` WHERE ip="' . $ip . '" LIMIT 1')) {
            $ourfails++;
            $wpdb->query('UPDATE `'.$table_prefix.'rusvc_login_lock` SET fails=' . $ourfails . ', unlock_time=' . $unlock_time . ' WHERE ip="' . $ip . '" LIMIT 1');
        }
        else
            $wpdb->query('INSERT INTO `'.$table_prefix.'rusvc_login_lock` (ip, fails, unlock_time) VALUES ("' . $ip . '", 1, ' . $unlock_time . ')');
    }
    return $user;
}

function rusvc_login_lock_delete() {
	global $wpdb;
	global $table_prefix;
	$wpdb->show_errors();
	$drop_tables = "DROP TABLE `".$table_prefix."rusvc_login_lock`";
	$wpdb->query($drop_tables);
	delete_option('rusvc_login_lock_blk_hours');
	delete_option('rusvc_login_lock_blk_fails');
}
register_uninstall_hook(__FILE__, 'rusvc_login_lock_delete');

function rusvc_login_lock_act() {
	global $wpdb;
	global $table_prefix;
	$wpdb->show_errors();
	add_option('rusvc_login_lock_blk_hours', 12);
	add_option('rusvc_login_lock_blk_fails', 3);
	$add_tables = "CREATE TABLE `".$table_prefix."rusvc_login_lock` ( bid int(11) UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY, ip varchar(43), fails tinyint(100) UNSIGNED, unlock_time bigint(21) UNSIGNED, INDEX bid (bid), INDEX ip (ip), INDEX fails (fails), INDEX unlock_time (unlock_time) )";
	$wpdb->query($add_tables);
}
register_activation_hook(__FILE__, 'rusvc_login_lock_act');

?>